//----------------------------------------------------------------------------
//
//		This file is part of the FALCON II.
//
//		The FALCON II is free software: you can redistribute it and/or modify
//		it under the terms of the GNU General Public License as published by
//		the Free Software Foundation, either version 3 of the License, or
//		(at your option) any later version.
//
//		The FALCON II is distributed in the hope that it will be useful,
//		but WITHOUT ANY WARRANTY; without even the implied warranty of
//		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//		GNU General Public License for more details.
//
//		You should have received a copy of the GNU General Public License
//		along with the FALCON II.  If not, see http://www.gnu.org/licenses/.
//
//		The FALCON II is copyright 2008-2009 by Timothy Pearson
//		tpearson@raptorengineeringinc.com
//		http://www.raptorengineeringinc.com
//
//----------------------------------------------------------------------------
//
//		The FALCON II is available as a reference design for the 
//		Raptor Engineering VDFPGA series of FPGA development boards
//		Please visit http://www.raptorengineeringinc.com for more information.
//
//----------------------------------------------------------------------------

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "connection.h"

#include "main.h"

GtkWidget *dialog, *label, *okay_button, *loginname, *passentry, *label2;
GtkWidget *text1, *text2;

#include <stdlib.h>
#include <time.h>

static int srand_called=0;

char *random_pw(char *dest)
{
	size_t len=0;
	char *p=dest;
	int three_in_a_row=0;
	int arr[128]={0x0};

	// Be sure to have called srand exactly one time
	if(!srand_called)
	{
		srandom(time(NULL));
		srand_called=1;
	}
	*dest=0x0; // Initialize the destination string
	for(len=6 + rand()%3; len; len--, p++) // Gen characters
	{
		char *q=dest;
		*p=(rand()%2)? rand()%26 + 97: rand()%10 + 48;
		p[1]=0x0;
		arr[*p]++;                         // Check values
		if(arr[*p]==3)
		{
			for(q=dest; q[2]>0 && !three_in_a_row; q++)	
				if(*q==q[1] && q[1]==q[2])
			   		three_in_a_row=1;
		}
		if(three_in_a_row || arr[*p]> 3 )
			return random_pw(dest);        // Values do not pass, try again
	}
    return dest;
}


void MsgBox(char *msgboxtext) {

	// Show a dialog box	
	dialog = gtk_dialog_new(); 	
	gtk_window_set_modal(GTK_WINDOW(dialog), TRUE);
	gtk_window_set_resizable(GTK_WINDOW(dialog), FALSE);
	gtk_window_set_title(GTK_WINDOW(dialog), "Falcon II Client Error");
	gtk_window_set_transient_for(GTK_WINDOW(dialog),GTK_WINDOW(main_window));
	text1 = gtk_label_new (" ");
	label = gtk_label_new (msgboxtext);	// Create the widgets of the dialog box
	text2 = gtk_label_new (" ");
	okay_button = gtk_button_new_with_label("OK");
		
	
	gtk_signal_connect_object(GTK_OBJECT (okay_button), "clicked", G_CALLBACK (gtk_widget_destroy), GTK_OBJECT(dialog));
	// Ensure that the dialog box is destroyed when the user clicks ok.
	gtk_container_add (GTK_CONTAINER (GTK_DIALOG(dialog)->action_area), okay_button); 	// Add the Okay Button to the dialof
	
	gtk_container_add (GTK_CONTAINER (GTK_DIALOG(dialog)->vbox), text1); 	// Add the label	
	gtk_container_add (GTK_CONTAINER (GTK_DIALOG(dialog)->vbox), label); 	// Add the label
	gtk_container_add (GTK_CONTAINER (GTK_DIALOG(dialog)->vbox), text2); 	// Add the label
	gtk_widget_show_all (dialog);						// Show everything in the dialog.
	// End showing a dialog box
}